diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-phy-operating-channel.cc ns-3.45/src/wifi/model/wifi-phy-operating-channel.cc
--- ns-3.44/src/wifi/model/wifi-phy-operating-channel.cc	2025-03-09 16:55:49.803372600 -0700
+++ ns-3.45/src/wifi/model/wifi-phy-operating-channel.cc	2025-06-01 20:34:45.629702300 -0700
@@ -258,6 +258,14 @@
     {143, MHz_u{6665}, MHz_u{160}, WIFI_PHY_BAND_6GHZ, FrequencyChannelType::OFDM},
     {175, MHz_u{6825}, MHz_u{160}, WIFI_PHY_BAND_6GHZ, FrequencyChannelType::OFDM},
     {207, MHz_u{6985}, MHz_u{160}, WIFI_PHY_BAND_6GHZ, FrequencyChannelType::OFDM},
+    // 320 MHz-1 channels
+    {31, MHz_u{6105}, MHz_u{320}, WIFI_PHY_BAND_6GHZ, FrequencyChannelType::OFDM},
+    {95, MHz_u{6425}, MHz_u{320}, WIFI_PHY_BAND_6GHZ, FrequencyChannelType::OFDM},
+    {159, MHz_u{6745}, MHz_u{320}, WIFI_PHY_BAND_6GHZ, FrequencyChannelType::OFDM},
+    // 320 MHz-2 channels
+    {63, MHz_u{6265}, MHz_u{320}, WIFI_PHY_BAND_6GHZ, FrequencyChannelType::OFDM},
+    {127, MHz_u{6585}, MHz_u{320}, WIFI_PHY_BAND_6GHZ, FrequencyChannelType::OFDM},
+    {191, MHz_u{6905}, MHz_u{320}, WIFI_PHY_BAND_6GHZ, FrequencyChannelType::OFDM},
 }};
 
 std::ostream&
@@ -600,6 +608,8 @@
     case 160:
         return (m_channelIts.size() == 2) ? WifiChannelWidthType::CW_80_PLUS_80MHZ
                                           : WifiChannelWidthType::CW_160MHZ;
+    case 320:
+        return WifiChannelWidthType::CW_320MHZ;
     case 2160:
         return WifiChannelWidthType::CW_2160MHZ;
     case 0:
@@ -810,58 +820,40 @@
 }
 
 std::set<uint8_t>
-WifiPhyOperatingChannel::Get20MHzIndicesCoveringRu(HeRu::RuSpec ru, MHz_u width) const
+WifiPhyOperatingChannel::Get20MHzIndicesCoveringRu(WifiRu::RuSpec ru, MHz_u width) const
 {
-    auto ruType = ru.GetRuType();
+    const auto ruType = WifiRu::GetRuType(ru);
 
-    NS_ASSERT_MSG(HeRu::GetBandwidth(ruType) <= width,
+    NS_ASSERT_MSG(WifiRu::GetBandwidth(ruType) <= width,
                   "No RU of type " << ruType << " is contained in a " << width << " MHz channel");
     NS_ASSERT_MSG(width <= GetTotalWidth(),
                   "The given width (" << width << " MHz) exceeds the operational width ("
                                       << GetTotalWidth() << ")");
 
-    // trivial case: 2x996-tone RU
-    if (ruType == HeRu::RU_2x996_TONE)
-    {
-        return {0, 1, 2, 3, 4, 5, 6, 7};
-    }
-
     // handle first the special case of center 26-tone RUs
-    if (ruType == HeRu::RU_26_TONE && ru.GetIndex() == 19)
+    if (const auto ruIndex = WifiRu::GetIndex(ru); ruType == RuType::RU_26_TONE && ruIndex == 19)
     {
+        NS_ASSERT_MSG(WifiRu::IsHe(ru), "Center 26-tone RUs can only be used with HE");
         NS_ASSERT_MSG(width >= MHz_u{80},
                       "26-tone RU with index 19 is only present in channels of at least 80 MHz");
         // the center 26-tone RU in an 80 MHz channel is not fully covered by
         // any 20 MHz channel, but by the two central 20 MHz channels in the 80 MHz channel
-        auto indices = ru.GetPrimary80MHz() ? GetAll20MHzChannelIndicesInPrimary(MHz_u{80})
-                                            : GetAll20MHzChannelIndicesInSecondary(MHz_u{80});
+        auto indices = std::get<HeRu::RuSpec>(ru).GetPrimary80MHz()
+                           ? GetAll20MHzChannelIndicesInPrimary(MHz_u{80})
+                           : GetAll20MHzChannelIndicesInSecondary(MHz_u{80});
         indices.erase(indices.begin());
         indices.erase(std::prev(indices.end()));
         return indices;
     }
 
-    auto ruIndex = ru.GetIndex();
-
-    if (ruType == HeRu::RU_26_TONE && ruIndex > 19)
+    auto ruPhyIndex = WifiRu::GetPhyIndex(ru, width, m_primary20Index);
+    if (ruType == RuType::RU_26_TONE && ruPhyIndex > 19)
     {
-        // "ignore" the center 26-tone RU in an 80 MHz channel
-        ruIndex--;
-    }
-
-    // if the RU refers to a 160 MHz channel, we have to update the RU index (which
-    // refers to an 80 MHz channel) if the RU is not in the lower 80 MHz channel
-    if (width == MHz_u{160})
-    {
-        bool primary80IsLower80 = (m_primary20Index < 4);
-        if (primary80IsLower80 != ru.GetPrimary80MHz())
+        // "ignore" the center 26-tone RUs in 80 MHz channels
+        ruPhyIndex--;
+        if (ruPhyIndex > 37)
         {
-            auto nRusIn80MHz = HeRu::GetNRus(MHz_u{80}, ruType);
-            // "ignore" the center 26-tone RU in an 80 MHz channel
-            if (ruType == HeRu::RU_26_TONE)
-            {
-                nRusIn80MHz--;
-            }
-            ruIndex += nRusIn80MHz;
+            ruPhyIndex -= (ruPhyIndex - 19) / 37;
         }
     }
 
@@ -869,29 +861,38 @@
 
     switch (ruType)
     {
-    case HeRu::RU_26_TONE:
-    case HeRu::RU_52_TONE:
-    case HeRu::RU_106_TONE:
-    case HeRu::RU_242_TONE:
+    case RuType::RU_26_TONE:
+    case RuType::RU_52_TONE:
+    case RuType::RU_106_TONE:
+    case RuType::RU_242_TONE:
         n20MHzChannels = 1;
         break;
-    case HeRu::RU_484_TONE:
+    case RuType::RU_484_TONE:
         n20MHzChannels = 2;
         break;
-    case HeRu::RU_996_TONE:
+    case RuType::RU_996_TONE:
         n20MHzChannels = 4;
         break;
+    case RuType::RU_2x996_TONE:
+        n20MHzChannels = 8;
+        break;
+    case RuType::RU_4x996_TONE:
+        n20MHzChannels = 16;
+        break;
     default:
         NS_ABORT_MSG("Unhandled RU type: " << ruType);
     }
 
-    auto nRusInCoveringChannel = HeRu::GetNRus(n20MHzChannels * MHz_u{20}, ruType);
+    auto nRusInCoveringChannel =
+        WifiRu::GetNRus(n20MHzChannels * MHz_u{20},
+                        ruType,
+                        WifiRu::IsHe(ru) ? WIFI_MOD_CLASS_HE : WIFI_MOD_CLASS_EHT);
     // compute the index (starting at 0) of the covering channel within the given width
-    std::size_t indexOfCoveringChannelInGivenWidth = (ruIndex - 1) / nRusInCoveringChannel;
+    std::size_t indexOfCoveringChannelInGivenWidth = (ruPhyIndex - 1) / nRusInCoveringChannel;
 
     // expand the index of the covering channel in the indices of its constituent
     // 20 MHz channels (within the given width)
-    NS_ASSERT(indexOfCoveringChannelInGivenWidth < 8); // max number of 20 MHz channels
+    NS_ASSERT(indexOfCoveringChannelInGivenWidth < 16); // max number of 20 MHz channels
     std::set<uint8_t> indices({static_cast<uint8_t>(indexOfCoveringChannelInGivenWidth)});
 
     while (n20MHzChannels > 1)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-phy-operating-channel.h ns-3.45/src/wifi/model/wifi-phy-operating-channel.h
--- ns-3.44/src/wifi/model/wifi-phy-operating-channel.h	2025-03-09 16:55:49.803372600 -0700
+++ ns-3.45/src/wifi/model/wifi-phy-operating-channel.h	2025-06-01 20:34:45.629702300 -0700
@@ -12,8 +12,7 @@
 
 #include "wifi-phy-band.h"
 #include "wifi-phy-common.h"
-
-#include "ns3/he-ru.h"
+#include "wifi-ru.h"
 
 #include <optional>
 #include <set>
@@ -388,7 +387,7 @@
      *              it is the width of the PPDU for which the RU is allocated
      * @return the channel indices of the minimum subset of 20 MHz channels containing the given RU
      */
-    std::set<uint8_t> Get20MHzIndicesCoveringRu(HeRu::RuSpec ru, MHz_u width) const;
+    std::set<uint8_t> Get20MHzIndicesCoveringRu(WifiRu::RuSpec ru, MHz_u width) const;
 
     /**
      * Get the index of the segment that contains a given primary channel.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-phy-state-helper.cc ns-3.45/src/wifi/model/wifi-phy-state-helper.cc
--- ns-3.44/src/wifi/model/wifi-phy-state-helper.cc	2025-03-09 16:55:49.803372600 -0700
+++ ns-3.45/src/wifi/model/wifi-phy-state-helper.cc	2025-06-01 20:34:45.629702300 -0700
@@ -482,11 +482,11 @@
 }
 
 void
-WifiPhyStateHelper::SwitchFromRxEndError()
+WifiPhyStateHelper::SwitchFromRxEndError(const WifiTxVector& txVector)
 {
     NS_LOG_FUNCTION(this);
     NS_ASSERT(m_endRx == Simulator::Now());
-    NotifyListeners(&WifiPhyListener::NotifyRxEndError);
+    NotifyListeners(&WifiPhyListener::NotifyRxEndError, txVector);
     DoSwitchFromRx();
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-phy-state-helper.h ns-3.45/src/wifi/model/wifi-phy-state-helper.h
--- ns-3.44/src/wifi/model/wifi-phy-state-helper.h	2025-03-09 16:55:49.803372600 -0700
+++ ns-3.45/src/wifi/model/wifi-phy-state-helper.h	2025-06-01 20:34:45.629702300 -0700
@@ -246,8 +246,10 @@
     void SwitchFromRxEndOk();
     /**
      * Switch from RX after the reception failed.
+     *
+     * @param txVector the TXVECTOR used for transmission of failed frame
      */
-    void SwitchFromRxEndError();
+    void SwitchFromRxEndError(const WifiTxVector& txVector);
     /**
      * Abort current reception following a CCA reset request.
      * @param operatingWidth the channel width the PHY is operating on
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-ppdu.cc ns-3.45/src/wifi/model/wifi-ppdu.cc
--- ns-3.44/src/wifi/model/wifi-ppdu.cc	2025-03-09 16:55:49.803372600 -0700
+++ ns-3.45/src/wifi/model/wifi-ppdu.cc	2025-06-01 20:34:45.630702300 -0700
@@ -100,6 +100,8 @@
     m_psdus = psdus;
 }
 
+WifiPpdu::~WifiPpdu() = default;
+
 const WifiTxVector&
 WifiPpdu::GetTxVector() const
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-ppdu.h ns-3.45/src/wifi/model/wifi-ppdu.h
--- ns-3.44/src/wifi/model/wifi-ppdu.h	2025-03-09 16:55:49.803372600 -0700
+++ ns-3.45/src/wifi/model/wifi-ppdu.h	2025-06-01 20:34:45.630702300 -0700
@@ -73,7 +73,7 @@
     /**
      * Destructor for WifiPpdu.
      */
-    virtual ~WifiPpdu() = default;
+    virtual ~WifiPpdu();
 
     /**
      * Get the TXVECTOR used to send the PPDU.
@@ -219,7 +219,7 @@
                                          always be obtained from the PHY headers, especially for
                                          non-HT PPDU, since we do not sense the spectrum to
                                          determine the occupied channel width for simplicity. */
-};                          // class WifiPpdu
+};
 
 /**
  * @brief Stream insertion operator.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-protection-manager.cc ns-3.45/src/wifi/model/wifi-protection-manager.cc
--- ns-3.44/src/wifi/model/wifi-protection-manager.cc	2025-03-09 16:55:49.803372600 -0700
+++ ns-3.45/src/wifi/model/wifi-protection-manager.cc	2025-06-01 20:34:45.630702300 -0700
@@ -85,11 +85,11 @@
     auto phy = m_mac->GetWifiPhy(m_linkId);
     std::size_t primaryIdx = phy->GetOperatingChannel().GetPrimaryChannelIndex(ctsTxWidth);
     std::size_t idx80MHz = MHz_u{80} / ctsTxWidth;
-    if ((phy->GetChannelWidth() == MHz_u{160}) && (ctsTxWidth <= MHz_u{40}) &&
+    if ((phy->GetChannelWidth() > MHz_u{80}) && (ctsTxWidth <= MHz_u{40}) &&
         (primaryIdx >= idx80MHz))
     {
-        // the primary80 is in the higher part of the 160 MHz channel
-        primaryIdx -= idx80MHz;
+        // get the index of the primary within the primary80
+        primaryIdx %= idx80MHz;
     }
     switch (static_cast<uint16_t>(ctsTxWidth))
     {
@@ -105,6 +105,9 @@
     case 160:
         ui.SetMuRtsRuAllocation(68);
         break;
+    case 320:
+        ui.SetMuRtsRuAllocation(69);
+        break;
     default:
         NS_ABORT_MSG("Unhandled TX width: " << ctsTxWidth << " MHz");
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-psdu.cc ns-3.45/src/wifi/model/wifi-psdu.cc
--- ns-3.44/src/wifi/model/wifi-psdu.cc	2025-03-09 16:55:49.803372600 -0700
+++ ns-3.45/src/wifi/model/wifi-psdu.cc	2025-06-01 20:34:45.630702300 -0700
@@ -131,11 +131,7 @@
 bool
 WifiPsdu::HasNav() const
 {
-    // When the contents of a received Duration/ID field, treated as an unsigned integer,
-    // are greater than 32 768, the contents are interpreted as appropriate for the frame
-    // type and subtype or ignored if the receiving MAC entity does not have a defined
-    // interpretation for that type and subtype (IEEE 802.11-2016 sec. 10.27.3)
-    return (m_mpduList.at(0)->GetHeader().GetRawDuration() & 0x8000) == 0;
+    return m_mpduList.at(0)->GetHeader().HasNav();
 }
 
 Time
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-radio-energy-model.cc ns-3.45/src/wifi/model/wifi-radio-energy-model.cc
--- ns-3.44/src/wifi/model/wifi-radio-energy-model.cc	2025-03-09 16:55:49.803372600 -0700
+++ ns-3.45/src/wifi/model/wifi-radio-energy-model.cc	2025-06-01 20:34:45.630702300 -0700
@@ -514,7 +514,7 @@
 }
 
 void
-WifiRadioEnergyModelPhyListener::NotifyRxEndError()
+WifiRadioEnergyModelPhyListener::NotifyRxEndError(const WifiTxVector& /* txVector */)
 {
     NS_LOG_FUNCTION(this);
     if (m_changeStateCallback.IsNull())
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-radio-energy-model.h ns-3.45/src/wifi/model/wifi-radio-energy-model.h
--- ns-3.44/src/wifi/model/wifi-radio-energy-model.h	2025-03-09 16:55:49.803372600 -0700
+++ ns-3.45/src/wifi/model/wifi-radio-energy-model.h	2025-06-01 20:34:45.630702300 -0700
@@ -56,7 +56,7 @@
 
     void NotifyRxStart(Time duration) override;
     void NotifyRxEndOk() override;
-    void NotifyRxEndError() override;
+    void NotifyRxEndError(const WifiTxVector& txVector) override;
     void NotifyTxStart(Time duration, dBm_u txPower) override;
     void NotifyCcaBusyStart(Time duration,
                             WifiChannelListType channelType,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-remote-station-manager.cc ns-3.45/src/wifi/model/wifi-remote-station-manager.cc
--- ns-3.44/src/wifi/model/wifi-remote-station-manager.cc	2025-03-09 16:55:49.803372600 -0700
+++ ns-3.45/src/wifi/model/wifi-remote-station-manager.cc	2025-06-01 20:34:45.630702300 -0700
@@ -45,6 +45,7 @@
         TypeId("ns3::WifiRemoteStationManager")
             .SetParent<Object>()
             .SetGroupName("Wifi")
+            // NS_DEPRECATED_3_44
             .AddAttribute("MaxSsrc",
                           "The maximum number of retransmission attempts for any packet with size "
                           "<= RtsCtsThreshold. "
@@ -54,6 +55,7 @@
                           MakeUintegerChecker<uint32_t>(),
                           TypeId::SupportLevel::OBSOLETE,
                           "Use WifiMac::FrameRetryLimit instead")
+            // NS_DEPRECATED_3_44
             .AddAttribute("MaxSlrc",
                           "The maximum number of retransmission attempts for any packet with size "
                           "> RtsCtsThreshold. "
@@ -74,18 +76,19 @@
                 BooleanValue(false),
                 MakeBooleanAccessor(&WifiRemoteStationManager::m_incrRetryCountUnderBa),
                 MakeBooleanChecker())
-            .AddAttribute("RtsCtsThreshold",
-                          "If the size of the PSDU is bigger than this value, we use an RTS/CTS "
-                          "handshake before sending the data frame."
-                          "This value will not have any effect on some rate control algorithms.",
-                          UintegerValue(4692480),
-                          MakeUintegerAccessor(&WifiRemoteStationManager::SetRtsCtsThreshold),
-                          MakeUintegerChecker<uint32_t>(0, 4692480))
+            .AddAttribute(
+                "RtsCtsThreshold",
+                "If the size of the PSDU is bigger than this value, we use an RTS/CTS "
+                "handshake before sending the data frame."
+                "This value will not have any effect on some rate control algorithms.",
+                UintegerValue(WIFI_DEFAULT_RTS_THRESHOLD),
+                MakeUintegerAccessor(&WifiRemoteStationManager::SetRtsCtsThreshold),
+                MakeUintegerChecker<uint32_t>(WIFI_MIN_RTS_THRESHOLD, WIFI_MAX_RTS_THRESHOLD))
             .AddAttribute("RtsCtsTxDurationThresh",
                           "If this threshold is a strictly positive value and the TX duration of "
                           "the PSDU is greater than or equal to this threshold, we use an RTS/CTS "
                           "handshake before sending the data frame.",
-                          TimeValue(Time{0}),
+                          TimeValue(),
                           MakeTimeAccessor(&WifiRemoteStationManager::m_rtsCtsTxDurationThresh),
                           MakeTimeChecker())
             .AddAttribute(
@@ -94,10 +97,10 @@
                 "size of the fragments are equal or smaller. "
                 "This value does not apply when it is carried in an A-MPDU. "
                 "This value will not have any effect on some rate control algorithms.",
-                UintegerValue(65535),
+                UintegerValue(WIFI_DEFAULT_FRAG_THRESHOLD),
                 MakeUintegerAccessor(&WifiRemoteStationManager::DoSetFragmentationThreshold,
                                      &WifiRemoteStationManager::DoGetFragmentationThreshold),
-                MakeUintegerChecker<uint32_t>())
+                MakeUintegerChecker<uint32_t>(WIFI_MIN_FRAG_THRESHOLD, WIFI_MAX_FRAG_THRESHOLD))
             .AddAttribute("NonUnicastMode",
                           "Wifi mode used for non-unicast transmissions.",
                           WifiModeValue(),
@@ -700,6 +703,32 @@
                         false);
 }
 
+void
+WifiRemoteStationManager::AdjustTxVectorForCtlResponse(WifiTxVector& txVector,
+                                                       MHz_u allowedWidth) const
+{
+    NS_LOG_FUNCTION(this << txVector << allowedWidth);
+
+    auto modulation = txVector.GetModulationClass();
+
+    if (allowedWidth >= 40 &&
+        (modulation == WIFI_MOD_CLASS_DSSS || modulation == WIFI_MOD_CLASS_HR_DSSS))
+    {
+        // control frame must be sent in a non-HT duplicate PPDU because it must protect a frame
+        // being transmitted on at least 40 MHz. Change the modulation class to ERP-OFDM and the
+        // rate to 6 Mbps
+        txVector.SetMode(ErpOfdmPhy::GetErpOfdmRate6Mbps());
+        modulation = txVector.GetModulationClass();
+    }
+    // do not set allowedWidth as the TX width if the modulation class is (HR-)DSSS (allowedWidth
+    // may be 20 MHz) or allowedWidth is 22 MHz (the selected modulation class may be OFDM)
+    if (modulation != WIFI_MOD_CLASS_DSSS && modulation != WIFI_MOD_CLASS_HR_DSSS &&
+        allowedWidth != 22)
+    {
+        txVector.SetChannelWidth(allowedWidth);
+    }
+}
+
 WifiTxVector
 WifiRemoteStationManager::GetRtsTxVector(Mac48Address address, MHz_u allowedWidth)
 {
@@ -722,24 +751,8 @@
     {
         v = DoGetRtsTxVector(Lookup(address));
     }
-    auto modulation = v.GetModulationClass();
 
-    if (allowedWidth >= 40 &&
-        (modulation == WIFI_MOD_CLASS_DSSS || modulation == WIFI_MOD_CLASS_HR_DSSS))
-    {
-        // RTS must be sent in a non-HT duplicate PPDU because it must protect a frame being
-        // transmitted on at least 40 MHz. Change the modulation class to ERP-OFDM and the rate
-        // to 6 Mbps
-        v.SetMode(ErpOfdmPhy::GetErpOfdmRate6Mbps());
-        modulation = v.GetModulationClass();
-    }
-    // do not set allowedWidth as the TX width if the modulation class is (HR-)DSSS (allowedWidth
-    // may be >= 40 MHz) or allowedWidth is 22 MHz (the selected modulation class may be OFDM)
-    if (modulation != WIFI_MOD_CLASS_DSSS && modulation != WIFI_MOD_CLASS_HR_DSSS &&
-        allowedWidth != 22)
-    {
-        v.SetChannelWidth(allowedWidth);
-    }
+    AdjustTxVectorForCtlResponse(v, allowedWidth);
 
     return v;
 }
@@ -808,6 +821,9 @@
     v.SetChannelWidth(m_wifiPhy->GetTxBandwidth(ackMode));
     v.SetGuardInterval(GetGuardIntervalForMode(ackMode, m_wifiPhy->GetDevice()));
     v.SetNss(1);
+
+    AdjustTxVectorForCtlResponse(v, dataTxVector.GetChannelWidth());
+
     return v;
 }
 
@@ -825,6 +841,9 @@
     v.SetChannelWidth(m_wifiPhy->GetTxBandwidth(blockAckMode));
     v.SetGuardInterval(GetGuardIntervalForMode(blockAckMode, m_wifiPhy->GetDevice()));
     v.SetNss(1);
+
+    AdjustTxVectorForCtlResponse(v, dataTxVector.GetChannelWidth());
+
     return v;
 }
 
@@ -1335,13 +1354,12 @@
 WifiRemoteStationManager::DoSetFragmentationThreshold(uint32_t threshold)
 {
     NS_LOG_FUNCTION(this << threshold);
-    if (threshold < 256)
+    if (threshold < WIFI_MIN_FRAG_THRESHOLD)
     {
-        /*
-         * ASN.1 encoding of the MAC and PHY MIB (256 ... 8000)
-         */
-        NS_LOG_WARN("Fragmentation threshold should be larger than 256. Setting to 256.");
-        m_fragmentationThreshold = 256;
+        NS_LOG_WARN("Fragmentation threshold should be larger than "
+                    << WIFI_MIN_FRAG_THRESHOLD << ". Setting to " << WIFI_MIN_FRAG_THRESHOLD
+                    << ".");
+        m_fragmentationThreshold = WIFI_MIN_FRAG_THRESHOLD;
     }
     else
     {
@@ -1468,12 +1486,8 @@
 std::shared_ptr<WifiRemoteStationState>
 WifiRemoteStationManager::LookupState(Mac48Address address) const
 {
-    NS_LOG_FUNCTION(this << address);
-    auto stateIt = m_states.find(address);
-
-    if (stateIt != m_states.end())
+    if (const auto stateIt = m_states.find(address); stateIt != m_states.cend())
     {
-        NS_LOG_DEBUG("WifiRemoteStationManager::LookupState returning existing state");
         return stateIt->second;
     }
 
@@ -1487,9 +1501,13 @@
     state->m_erpOfdmSupported = false;
     state->m_ofdmSupported = false;
     state->m_htCapabilities = nullptr;
+    state->m_htOperation = nullptr;
     state->m_vhtCapabilities = nullptr;
+    state->m_vhtOperation = nullptr;
     state->m_heCapabilities = nullptr;
+    state->m_heOperation = nullptr;
     state->m_ehtCapabilities = nullptr;
+    state->m_ehtOperation = nullptr;
     state->m_mleCommonInfo = nullptr;
     state->m_emlsrEnabled = false;
     state->m_channelWidth = m_wifiPhy->GetChannelWidth();
@@ -1571,6 +1589,18 @@
 }
 
 void
+WifiRemoteStationManager::AddStationHtOperation(Mac48Address from, const HtOperation& htOperation)
+{
+    NS_LOG_FUNCTION(this << from << htOperation);
+    auto state = LookupState(from);
+    if (htOperation.GetStaChannelWidth() == 0)
+    {
+        state->m_channelWidth = MHz_u{20};
+    }
+    state->m_htOperation = Create<const HtOperation>(htOperation);
+}
+
+void
 WifiRemoteStationManager::AddStationExtendedCapabilities(
     Mac48Address from,
     const ExtendedCapabilities& extendedCapabilities)
@@ -1609,6 +1639,34 @@
 }
 
 void
+WifiRemoteStationManager::AddStationVhtOperation(Mac48Address from,
+                                                 const VhtOperation& vhtOperation)
+{
+    NS_LOG_FUNCTION(this << from << vhtOperation);
+    auto state = LookupState(from);
+    /*
+     * Table 9-274 (VHT Operation Information subfields) of 802.11-2020:
+     * Set to 0 for 20 MHz or 40 MHz BSS bandwidth.
+     * Set to 1 for 80 MHz, 160 MHz or 80+80 MHz BSS bandwidth.
+     */
+    if (vhtOperation.GetChannelWidth() == 0)
+    {
+        state->m_channelWidth = std::min(MHz_u{40}, state->m_channelWidth);
+    }
+    else if (vhtOperation.GetChannelWidth() == 1)
+    {
+        state->m_channelWidth = std::min(MHz_u{160}, state->m_channelWidth);
+    }
+    state->m_vhtOperation = Create<const VhtOperation>(vhtOperation);
+}
+
+Ptr<const VhtOperation>
+WifiRemoteStationManager::GetStationVhtOperation(Mac48Address from)
+{
+    return LookupState(from)->m_vhtOperation;
+}
+
+void
 WifiRemoteStationManager::AddStationHeCapabilities(Mac48Address from,
                                                    const HeCapabilities& heCapabilities)
 {
@@ -1626,6 +1684,10 @@
         {
             state->m_channelWidth = MHz_u{80};
         }
+        else if (heCapabilities.GetChannelWidthSet() == 0x00)
+        {
+            state->m_channelWidth = MHz_u{20};
+        }
         // For other cases at 5 GHz, the supported channel width is set by the VHT capabilities
     }
     else if (m_wifiPhy->GetPhyBand() == WIFI_PHY_BAND_2_4GHZ)
@@ -1660,6 +1722,34 @@
 }
 
 void
+WifiRemoteStationManager::AddStationHeOperation(Mac48Address from, const HeOperation& heOperation)
+{
+    NS_LOG_FUNCTION(this << from << heOperation);
+    auto state = LookupState(from);
+    if (auto operation6GHz = heOperation.m_6GHzOpInfo)
+    {
+        switch (operation6GHz->m_chWid)
+        {
+        case 0:
+            state->m_channelWidth = MHz_u{20};
+            break;
+        case 1:
+            state->m_channelWidth = MHz_u{40};
+            break;
+        case 2:
+            state->m_channelWidth = MHz_u{80};
+            break;
+        case 3:
+            state->m_channelWidth = MHz_u{160};
+            break;
+        default:
+            NS_FATAL_ERROR("Invalid channel width value in 6 GHz Operation Information field");
+        }
+    }
+    state->m_heOperation = Create<const HeOperation>(heOperation);
+}
+
+void
 WifiRemoteStationManager::AddStationHe6GhzCapabilities(
     const Mac48Address& from,
     const He6GhzBandCapabilities& he6GhzCapabilities)
@@ -1678,6 +1768,12 @@
     // Used by all stations to record EHT capabilities of remote stations
     NS_LOG_FUNCTION(this << from << ehtCapabilities);
     auto state = LookupState(from);
+    if (ehtCapabilities.m_phyCapabilities.support320MhzIn6Ghz &&
+        (m_wifiPhy->GetPhyBand() == WIFI_PHY_BAND_6GHZ))
+    {
+        state->m_channelWidth = MHz_u{320};
+    }
+    // For other cases, the supported channel width is set by the HT/VHT capabilities
     for (const auto& mcs : m_wifiPhy->GetMcsList(WIFI_MOD_CLASS_EHT))
     {
         for (uint8_t mapType = 0; mapType < EhtMcsAndNssSet::EHT_MCS_MAP_TYPE_MAX; ++mapType)
@@ -1694,6 +1790,38 @@
 }
 
 void
+WifiRemoteStationManager::AddStationEhtOperation(Mac48Address from,
+                                                 const EhtOperation& ehtOperation)
+{
+    NS_LOG_FUNCTION(this << from << ehtOperation);
+    auto state = LookupState(from);
+    if (auto opControl = ehtOperation.m_opInfo)
+    {
+        switch (opControl->control.channelWidth)
+        {
+        case 0:
+            state->m_channelWidth = MHz_u{20};
+            break;
+        case 1:
+            state->m_channelWidth = MHz_u{40};
+            break;
+        case 2:
+            state->m_channelWidth = MHz_u{80};
+            break;
+        case 3:
+            state->m_channelWidth = MHz_u{160};
+            break;
+        case 4:
+            state->m_channelWidth = MHz_u{320};
+            break;
+        default:
+            NS_FATAL_ERROR("Invalid channel width value in EHT Operation Information field");
+        }
+    }
+    state->m_ehtOperation = Create<const EhtOperation>(ehtOperation);
+}
+
+void
 WifiRemoteStationManager::AddStationMleCommonInfo(
     Mac48Address from,
     const std::shared_ptr<CommonInfoBasicMle>& mleCommonInfo)
@@ -1702,8 +1830,9 @@
     auto state = LookupState(from);
     state->m_mleCommonInfo = mleCommonInfo;
     // insert another entry in m_states indexed by the MLD address and pointing to the same state
-    const_cast<WifiRemoteStationManager*>(this)->m_states.insert(
-        {mleCommonInfo->m_mldMacAddress, state});
+    const_cast<WifiRemoteStationManager*>(this)->m_states.insert_or_assign(
+        mleCommonInfo->m_mldMacAddress,
+        state);
 }
 
 Ptr<const HtCapabilities>
@@ -1712,6 +1841,12 @@
     return LookupState(from)->m_htCapabilities;
 }
 
+Ptr<const HtOperation>
+WifiRemoteStationManager::GetStationHtOperation(Mac48Address from)
+{
+    return LookupState(from)->m_htOperation;
+}
+
 Ptr<const ExtendedCapabilities>
 WifiRemoteStationManager::GetStationExtendedCapabilities(const Mac48Address& from)
 {
@@ -1730,6 +1865,12 @@
     return LookupState(from)->m_heCapabilities;
 }
 
+Ptr<const HeOperation>
+WifiRemoteStationManager::GetStationHeOperation(Mac48Address from)
+{
+    return LookupState(from)->m_heOperation;
+}
+
 Ptr<const He6GhzBandCapabilities>
 WifiRemoteStationManager::GetStationHe6GhzCapabilities(const Mac48Address& from) const
 {
@@ -1742,6 +1883,12 @@
     return LookupState(from)->m_ehtCapabilities;
 }
 
+Ptr<const EhtOperation>
+WifiRemoteStationManager::GetStationEhtOperation(Mac48Address from)
+{
+    return LookupState(from)->m_ehtOperation;
+}
+
 std::optional<std::reference_wrapper<CommonInfoBasicMle::EmlCapabilities>>
 WifiRemoteStationManager::GetStationEmlCapabilities(const Mac48Address& from)
 {
